// <lib/strutility.h> 񃆁[eBeB

#ifndef __LIB_STRUTILITY
#define __LIB_STRUTILITY

// ̔zin1~n2̂Qzjpp̃[eBeB

#include <string.h>
#include <lib/utility.h>

//--- s1s2w̔r֐i~pFs1 > s2j---//
inline static int strrcmp(const void *s1, const void *s2)
{
	int cmp = strcmp((const char *)s1, (const char *)s2);
	return (cmp < 0) ? 1 : (cmp == 0) ? 0 : -1;
}

//--- psƈv镶`T ---//
#define str_ssearch(s, p, n1, n2)                                               \
			ssearch((const void *)s, (const void *)p, (size_t)n1, (size_t)n2,   \
					(int(*)(const void *, const void *))strcmp)

//--- psƈv镶QT ---//
#define str_bsearch(s, p, n1, n2)                                               \
			bsearch((const void *)s, (const void *)p, (size_t)n1, (size_t)n2,   \
					(int(*)(const void *, const void *))strcmp)

//--- psƈv镶QTi擪vfj---//
#define str_bsearchx(s, p, n1, n2)                                              \
			bsearchx((const void *)s, (const void *)p, (size_t)n1, (size_t)n2,  \
					(int(*)(const void *, const void *))strcmp)

//--- pɃ\[gij---//
#define str_qsort(p, n1, n2)                                        \
			qsort((const void *)p, (size_t)n1, (size_t)n2,          \
					(int(*)(const void *, const void *))strcmp)

//--- p~Ƀ\[gij---//
#define str_qsortr(p, n1, n2)                                       \
			qsort((const void *)p, (size_t)n1, (size_t)n2,          \
					(int(*)(const void *, const void *))strrcmp)

//--- pɃ\[gij---//
#define str_msort(p, n1, n2)                                        \
			msort((const void *)p, (size_t)n1, (size_t)n2,          \
					(int(*)(const void *, const void *))strcmp)

//--- p~Ƀ\[gij---//
#define str_msortr(p, n1, n2)                                       \
			msort((const void *)p, (size_t)n1, (size_t)n2,          \
					(int(*)(const void *, const void *))strrcmp)

//--- p͏Ƀ\[g݂ ---//
#define str_is_sorted(p, n1, n2)                                     \
			is_sorted((const void *)p, (size_t)n1, (size_t)n2,       \
						(int(*)(const void *, const void *))strcmp)

//--- p͍~Ƀ\[g݂ ---//
#define str_is_sortedr(p, n1, n2)                                    \
			is_sorted((const void *)p, (size_t)n1, (size_t)n2,       \
						(int(*)(const void *, const void *))strrcmp)

// i̐擪jւn̃|C^̔zpp̃[eBeB

//--- s1s2w̔r֐ipFs1 < s2j---//
inline static int pstrcmp(const void *s1, const void *s2)
{
	return strcmp(*(const char **)s1, *(const char **)s2);
}

//--- s1s2w̔r֐i~pFs1 > s2j---//
inline static int pstrrcmp(const void *s1, const void *s2)
{
	int cmp = strcmp(*(const char **)s1, *(const char **)s2);
	return (cmp < 0) ? 1 : (cmp == 0) ? 0 : -1;
}

//--- psƈv镶`T ---//
#define pstr_ssearch(s, p, n)                                       \
			ssearch((const void *)s, (const void *)p, (size_t)n,    \
					sizeof(char *), pstrcmp);

//--- psƈv镶QT ---//
#define pstr_bsearch(s, p, n)                                       \
			bsearch((const void *)s, (const void *)p, (size_t)n,    \
					sizeof(char *), pstrcmp);

//--- psƈv镶QTi擪vfj---//
#define pstr_bsearchx(s, p, n)                                      \
			bsearchx((const void *)s, (const void *)p, (size_t)n,   \
					sizeof(char *), pstrcmp);

//--- pɃ\[gij---//
#define pstr_qsort(s, n)                                                \
			qsort((const void *)p, (size_t)n, sizeof(char *), pstrcmp);

//--- p~Ƀ\[gij---//
#define pstr_qsortr(s, n)                                               \
			qsort((const void *)p, (size_t)n, sizeof(char *), pstrrcmp);

//--- pɃ\[gij---//
#define pstr_msort(s, n)                                                \
			msort((const void *)p, (size_t)n, sizeof(char *), pstrcmp);

//--- p~Ƀ\[gij---//
#define pstr_msortr(s, n)                                               \
			msort((const void *)p, (size_t)n, sizeof(char *), pstrrcmp);

//--- p͏Ƀ\[g݂ ---//
#define pstr_is_sorted(p, n) is_sorted((const void *)p, (size_t)n, \
			sizeof(char *), pstrcmp)

//--- p͍~Ƀ\[g݂ ---//
#define pstr_is_sortedr(p, n) is_sorted((const void *)p, (size_t)n, \
			sizeof(char *), pstrrcmp)

#endif
