#include <limits.h>
#include <string.h>

//--- Boyer-Moore@ɂ镶TïvTj ---//
char *strrstr(const char *s1, const char *s2)
{
	size_t pt;								// s1ȂJ[\
	size_t pp;								// s2ȂJ[\
	size_t s1_len = strlen(s1);				// s1̕
	size_t s2_len = strlen(s2);				// s2̕
	size_t skip[UCHAR_MAX + 1];				// XLbve[u

	if (s2_len == 0)						// s2̒0ł
		return s1;							// s1̂܂ܕԂ
	for (pt = 0; pt <= UCHAR_MAX; pt++)		// XLbve[u̍쐬
		skip[pt] = s2_len;
	for (pt = s2_len - 1; pt > 0; pt--)
		skip[s2[pt]] = pt;
	pt = s1_len - s2_len;

	while (pt >= 0) {
		pp = 0;									// s2̐擪ɒ
		while (s1[pt] == s2[pp]) {
			if (pp == s2_len - 1)
				return s1 + pt - s2_len + 1;	// T
			pp++;
			pt++;
		}
		pt -= skip[s1[pt]];
	}

	return NULL;								// Ts
}