#include <lib/exlimits.h>

//--- int^ln̓\01ŕ\sɊi[ĕԋp ---//
char *itobstr(int n)
{
	static char s[INT_BIT + 1];			// i[敶

	union {
		int          s;
		unsigned int u;
	} bits = {.s = n};

	for (int i = INT_BIT - 1; i >= 0 ; i--)
		s[INT_BIT - i - 1] = ((bits.u >> i) & 1U) ? '1' : '0';
	s[INT_BIT] = '\0';

	return s;
}

//--- short^ln̓\01ŕ\sɊi[ĕԋp ---//
char *stobstr(short n)
{
	static char s[SHRT_BIT + 1];			// i[敶

	union {
		short          s;
		unsigned short u;
	} bits = {.s = n};

	for (int i = SHRT_BIT - 1; i >= 0 ; i--)
		s[INT_BIT - i - 1] = ((bits.u >> i) & 1U) ? '1' : '0';
	s[SHRT_BIT] = '\0';

	return s;
}

//--- long^ln̓\01ŕ\sɊi[ĕԋp ---//
char *ltobstr(long n)
{
	static char s[LONG_BIT + 1];			// i[敶

	union {
		long          s;
		unsigned long u;
	} bits = {.s = n};

	for (int i = LONG_BIT - 1; i >= 0 ; i--)
		s[LONG_BIT - i - 1] = ((bits.u >> i) & 1U) ? '1' : '0';
	s[LONG_BIT] = '\0';

	return s;
}

//--- long long^ln̓\01ŕ\sɊi[ĕԋp ---//
char *lltobstr(long n)
{
	static char s[LLONG_BIT + 1];			// i[敶

	union {
		long long          s;
		unsigned long long u;
	} bits = {.s = n};

	for (int i = LLONG_BIT - 1; i >= 0 ; i--)
		s[LLONG_BIT - i - 1] = ((bits.u >> i) & 1U) ? '1' : '0';
	s[LLONG_BIT] = '\0';

	return s;
}
