// ėp\[g֐i}[W\[gɂȃ\[gj

// basewvf̑傫sizeŗvfnmemb̔z
// r֐comparpĈɃ\[g
#include <stdlib.h>
#include <string.h>
#include <lib/swap.h>

#define INSERTIONSORT_THRESHOLD		7		// ̗vf͑}\[g

//--- xywnoCg̗̈ ---//
static void memswap(void *x, void *y, size_t n)
{
	unsigned char *a = (unsigned char *)x;
	unsigned char *b = (unsigned char *)y;

	for ( ; n--; a++, b++)
		swap(unsigned char, *a, *b);
}

static size_t __sz;									// vf̑傫
static int (*__comp)(const void *, const void *);	// r֐

//--- vfa[idx]ANZX ---//
#define E(a, idx)					((void *)&a[(idx) * __sz])

//--- vfa[idx1]Ɨvfa[idx2]r ---//
#define comp(a, idx1, idx2)			__comp(E(a, idx1), E(a, idx2))

//--- vfa[idx1]Ɨvfa[idx2] ---//
#define swap_elem(a, idx1, idx2)	memswap(E(a, idx1), E(a, idx2), __sz)

//--- }W\[g ---//
static void merge_sort(char *src, char *dest, int low, int high, int off)
{
	int length = high - low;

	if (length < INSERTIONSORT_THRESHOLD) {		// vfz
		for (int i = low; i < high; i++)		// ΂Ă͑}\[gKp
			for (int j = i; j > low && comp(dest, j-1, j) > 0; j--)
				swap_elem(dest, j, j - 1);
		return;
	} else {
		int dest_low  = low;
		int dest_high = high;

		low  += off;
		high += off;
		int mid = (low + high) / 2;

		merge_sort(dest, src, low, mid,  -off);
		merge_sort(dest, src, mid, high, -off);

		if (comp(src, mid - 1, mid) <= 0) {
			memcpy(dest + dest_low * __sz, src + low * __sz, length * __sz);
			return;
		}

		for (int i = dest_low, p = low, q = mid; i < dest_high; i++) {
			if (q >= high || p < mid && comp(src, p, q) <= 0)
				memcpy(E(dest, i), E(src, p++), __sz);
			else
				memcpy(E(dest, i), E(src, q++), __sz);
		}
	}
}

//--- sizeoCg~nmemb̔zbaser֐comparpă}[W\[g ---//
void msort(void *base, size_t nmemb, size_t size, 
		   int (*compar)(const void *, const void *))
{
	char *p = calloc(nmemb, size);			// obt@m
	__sz = size;
	__comp = compar;

	if (p == NULL) {						// mۂɎs}\[g
		char *x = (char *)base;
		for (size_t i = 1; i < nmemb; i++)
			for (size_t j = i; j > 0 && comp(x, j - 1, j) > 0; j--)
				swap_elem(x, j, j - 1);
	} else {
		memcpy(p, base, nmemb * size);		// zobt@ɃRs[
		merge_sort(p, base, 0, nmemb, 0);	// }[W\[g
		free(p);
	}
}
