// ėpQT؁iPł̗pFf[^L[͐j

#include <stdio.h>
#include <string.h>
#include "bintree.h"

//--- j[ ---//
typedef enum {
	Term, Insert, Remove, Search, Print
} Menu;

//--- j[I ---//
Menu SelectMenu(void)
{
	int ch;

	do {
		printf("\n(1)}  (2)폜  (3)T  (4)\  (0)I : ");
		scanf("%d", &ch);
	} while (ch < Term || ch > Print);
	return (Menu)ch;
}

//--- f[^̓ ---//
void Read(const char *message, int *temp)
{
	printf("%s鐮͂Ă : ", message);
	scanf("%d", temp);
}

//--- \֐ ---//
void print_int(int *n)
{
	printf("%d\n", *n);
}

//--- r֐ ---//
int int_cmp(const int *a, const int *b)
{
   return *a < *b ? -1 : *a > *b ? 1 : 0;
}

//--- C֐ ---//
int main(void)
{
	Menu    menu;
	BinTree bt;
	BTinitialize(&bt, int_cmp);		// QT؂̏

	do {
		int no;
		BinNode *p;
		switch (menu = SelectMenu()) {
		 case Insert :	Read("}", &no);
						if (!(p = BTinsert(&bt, &no, sizeof(int))))
							printf("}s\n");
						break;

		 case Remove :	Read("폜", &no);
						if (!BTremove(&bt, &no))
							printf("폜s\n");
						break;

		 case Search :	Read("T", &no);
						if (p = BTsearch(&bt, &no))
							printf("%d\n", *(int *)p->ptr);
						else
							printf("Ts\n");
						break;

		 case Print	 :	puts("--- ꗗ\ ---");
						BTprint(&bt, (void (*)(const void *))print_int);
						break;
		}
	} while (menu != Term);

	BTfinalize(&bt);				// QT؂̏I

	return 0;
}
