// ėpQT؁iPł̗pFf[^͍\̂ŃL[̓oj

#include <stdio.h>
#include <string.h>
#include "bintree.h"

//---  ---//
typedef struct {
	int  no;			// ԍ
	char name[13];		// O
	int  height;		// g
} Member;

//--- Member^̔r֐iOnameL[j---//
int Member_cmp(const Member *x, const Member *y)
{
	return strcmp(x->name, y->name);
}

//--- j[ ---//
typedef enum {
	Term, Insert, Remove, Search, Print
} Menu;

//--- j[I ---//
Menu SelectMenu(void)
{
	int ch;

	do {
		printf("\n(1)}  (2)폜  (3)T  (4)\  (0)I : ");
		scanf("%d", &ch);
	} while (ch < Term || ch > Print);
	return (Menu)ch;
}

//--- f[^̓́iSoj ---//
void Read(const char *message, Member *temp)
{
	printf("%s͂Ă B\n", message);
	printf("ԍF");   scanf("%d", &(temp->no));
	printf("O@@F");   scanf("%s",   temp->name);
	printf("g@@F");   scanf("%d", &(temp->height));
}

//--- f[^̓́iL[j ---//
void ReadKey(const char *message, Member *temp)
{
	printf("%s̖OF", message);
	scanf("%s", temp->name);
}

//--- Member^̑So̒l\ ---//
void Member_print(const Member *x)
{
	printf("[%02d] %-12.12s%4d\n", x->no, x->name, x->height);
}

//--- C֐ ---//
int main(void)
{
	Menu    menu;
	BinTree bt;
	BTinitialize(&bt, Member_cmp);	// QT؂̏

	do {
		Member mem;
		BinNode *p;
		switch (menu = SelectMenu()) {
		 case Insert :	Read("}", &mem);
						if (!(p = BTinsert(&bt, &mem, sizeof(Member))))
							printf("}s\n");
						break;

		 case Remove :	ReadKey("폜", &mem);
						if (!BTremove(&bt, &mem))
							printf("폜s\n");
						break;

		 case Search :	ReadKey("T", &mem);
						if (p = BTsearch(&bt, &mem))
							Member_print(p->ptr);
						else
							printf("Ts\n");
						break;

		 case Print	 :	puts("--- ꗗ\ ---");
						BTprint(&bt, (void (*)(const void *))Member_print);
						break;
		}
	} while (menu != Term);

	BTfinalize(&bt);				// QT؂̏I

	return 0;
}
