// ėpQT؁iQł̗pFf[^L[͕j

#include <stdio.h>
#include <string.h>
#include "bintree.h"

//--- j[ ---//
typedef enum {
	Term, Insert, Remove, Search, Next, Prev, Print
} Menu;

//--- j[I ---//
Menu SelectMenu(void)
{
	int ch;

	do {
		printf("\n(1)} (2)폜 (3)T (4)m[h (5)Om[h (6)\"
               "  (0)I : ");
		scanf("%d", &ch);
	} while (ch < Term || ch > Print);
	return (Menu)ch;
}

//--- f[^̓ ---//
void Read(const char *message, char *temp)
{
	printf("%s镶͂Ă : ", message);
	scanf("%s", temp);
}

//--- \֐ ---//
void print_string(const char *s)
{
	printf("%s\n", s);
}

//--- C֐ ---//
int main(void)
{
	Menu    menu;
	BinTree bt;
	BTinitialize(&bt, strcmp, 100);		// QT؂̏

	do {
		char temp[128];
		BinNode *p;
		switch (menu = SelectMenu()) {
		 case Insert :	Read("}", temp);
						if (!(p = BTinsert(&bt, temp, strlen(temp)+1)))
							printf("}s\n");
						break;

		 case Remove :	Read("폜", temp);
						if (!BTremove(&bt, temp))
							printf("폜s\n");
						break;

		 case Search :	Read("T", temp);
						if (p = BTsearch(&bt, temp))
							printf("%s\n", (const char *)p->ptr);
						else
							printf("Ts\n");
						break;

		 case Next :	if (p = BTsearchNext(&bt))
							printf("%s\n", (const char *)p->ptr);
						else
							printf("Ts\n");
						break;

		 case Prev :	if (p = BTsearchPrev(&bt))
							printf("%s\n", (const char *)p->ptr);
						else
							printf("Ts\n");
						break;

		 case Print	 :	puts("--- ꗗ\ ---");
						BTprint(&bt, (void (*)(const void *))print_string);
						break;
		}
	} while (menu != Term);

	BTfinalize(&bt);				// QT؂̏I

	return 0;
}
